CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000            
  
OBJ
  Sio : "FullDuplexSerialPlus"
  
VAR
  long fb[5120]            ' Frame buffer (in longs)
  long start, end          ' time hacks
  long val, tmp, index, fbPtr, i
PUB Main
  Sio.Start(31, 30, 0, 115200)
  waitcnt(clkfreq * 3 + cnt)
  fbPtr := @fb
  FillSome
  DisplaySome
  start := cnt
  repeat index from 0 to (5119)          ' For each long in the buffer...    263 milliseconds
    val := LONG[fbPtr][index]                         ' Read value from memory
    tmp.BYTE[0] := val.BYTE[3]                        ' move Y0 into array location 0
    tmp.BYTE[2] := val.BYTE[1]                        ' move Y1 into array location 2
    LONG[fbPtr][index] := tmp                         ' write long back into main memory      
  end := cnt
  Sio.dec(end - start)
  Sio.tx(13)
  DisplaySome
  FillSome
  Sio.Str(string("*************************************",13))
  DisplaySome
  start := cnt
  repeat index from 0 to (5119)          ' For each long in the buffer...    117 milliseconds saves 146 milliseconds
    long[fbPtr][index] <-= 8
  end := cnt
  sio.dec(end - start)
  Sio.tx(13)
  DisplaySome
  
Pri FillSome 
  repeat i from 0 to 3
    tmp := 0
    tmp.byte[0] := i * 4 + 0
    tmp.byte[1] := i * 4 + 1
    tmp.byte[2] := i * 4 + 2
    tmp.byte[3] := i * 4 + 3
    long[fbPtr][i] := tmp
    
Pri DisplaySome 
  repeat i from 0 to 3
    tmp := long[fbPtr][i]
    Sio.dec(tmp.byte[0])
    Sio.tx(9)
    Sio.dec(tmp.byte[1])
    Sio.tx(9)
    Sio.dec(tmp.byte[2])
    Sio.tx(9)
    Sio.dec(tmp.byte[3])
    Sio.tx(13)
{ Outputs from run
0       1       2       3
4       5       6       7
8       9       10      11
12      13      14      15
25314192
3       13      1       15
7       13      5       15
11      13      9       15
15      13      13      15
*************************************
0       1       2       3
4       5       6       7
8       9       10      11
12      13      14      15
11223952
3       0       1       2
7       4       5       6
11      8       9       10
15      12      13      14
Original  is 264 milliseconds.  Rotate version is 117 milliseconds.  Savings of 147 milliseconds    }
      